#pragma once

#include "Common.h"

struct aiNode;

namespace Library
{
    class Game;
    class Mesh;
    class ModelMaterial;

    class Model
    {
		friend class Mesh;

    public:
        Model(Game& game, const std::string& filename, bool flipUVs = false);
        ~Model();

        Game& GetGame();
        bool HasMeshes() const;
        bool HasMaterials() const;
		bool HasAnimations() const;

        const std::vector<Mesh*>& Meshes() const;
        const std::vector<ModelMaterial*>& Materials() const;

    private:
        Model(const Model& rhs);
        Model& operator=(const Model& rhs);

        Game& mGame;
        std::vector<Mesh*> mMeshes;
        std::vector<ModelMaterial*> mMaterials;
    };
}
